#include <3048F.H>
#include "w6v5a.h"

/*O`XXX̐VA|[giuaĂobj͂*/
unsigned int read_i_sci1(void)
{
unsigned int	k, data, bitptn;

	data = 0;
	bitptn = 100;
	for(k = 0; k < 3; k++)
	{
		data = data + (read_c_sci(1) - '0') * bitptn;
		bitptn = bitptn / 10;
	}
	return(data);
}


/*O`UTTRT̐VA|[giuaĂobj͂*/
unsigned int read_ii_sci1(void)
{
unsigned int	k, data, bitptn;

	data = 0;
	bitptn = 10000;
	for(k = 0; k < 5; k++)
	{
		data = data + (read_c_sci(1) - '0') * bitptn;
		bitptn = bitptn / 10;
	}
	return(data);
}

/*O`UTTRT̐VA|[giCbotj͂*/
unsigned int read_ii_sci1b(void)
{
unsigned int	data;
unsigned int	data_L, data_H;

	data_H = (unsigned int)read_c_sci(1);
	data_L = (unsigned int)read_c_sci(1);
	data = data_H * 256 + data_L;
	return(data);
}

/**********************************************/
/*charϐPoCgVA|[g͂*/
/*͂܂ő҂                          */
/**********************************************/
unsigned char read_c_sci(unsigned char ch)
{
unsigned char	data;

	if(ch == 1)
	{
		while(SCI1.SSR.BIT.RDRF == 0);
		data = SCI1.RDR;
		SCI1.SSR.BIT.RDRF = 0;
	}
	else
	{
		while(SCI0.SSR.BIT.RDRF == 0);
		data = SCI0.RDR;
		SCI0.SSR.BIT.RDRF = 0;
	}

	return(data);
}

/*charϐPoCgVA|[g͂*/
/*read_c_sciƂ́A͂Ȃ΂OŖ߂_قȂ*/
unsigned char read_c_scib(unsigned char ch)
{
unsigned char	data;

	if(ch == 1)
	{
		if(SCI1.SSR.BIT.RDRF == 0)
		{
			return(0);
		}
		data = SCI1.RDR;
		SCI1.SSR.BIT.RDRF = 0;
	}
	else
	{
		if(SCI0.SSR.BIT.RDRF == 0)
		{
			return(0);
		}
		data = SCI0.RDR;
		SCI0.SSR.BIT.RDRF = 0;
	}

	return(data);
}
/*charϐPoCgVA|[g֏o͂*/
void print_c_sci1(unsigned char	data)
{

	while(SCI1.SSR.BIT.TDRE == 0);
	SCI1.TDR = data;
	SCI1.SSR.BIT.TDRE = 0;

	return;
}
/*unsigned int ϐ 2 oCgVA|[g֏o͂*/
void print_cc_sci1(unsigned int data)
{
unsigned int	ii;
unsigned char	data_L, data_H;

	if(data > 255)
	{
		ii = data / 256;
		data_H = (unsigned char)ii;
	}
	else
	{
		data_H = 0;
	}

	ii = data - ii * 256;
	data_L = (unsigned char)ii;

	print_c_sci1(data_H);
	print_c_sci1(data_L);

	return;
}


/*charϐ80oCg max VA|[g֏o͂ibXgOj*/
void print_s_sci1(char string[80])
{
unsigned char	i;

	i = 0;
	do
	{
		print_c_sci1(string[i]);
		i++;
	}while(string[i] != 0 && i < 80);

	print_c_sci1(0x0d);
	print_c_sci1(0x0a);

	return;
}

/*************************************************/
/*̐^[~iʂɕ\(AsciiR[ho)*/
void print_ii_sci1(unsigned int data)
{
unsigned int		org_data;
unsigned int		i, j, bitptn;
char		string[80];

	org_data = data;

	bitptn = 10000;
	for(i = 0; i < 5; i++)
	{
		j = data / bitptn;
		string[i] = '0' + j;
		data = data - bitptn * j;
		bitptn = bitptn / 10;
	}

	for(i = 0; i < 4; i++)
	{
		if(string[i] == '0') string[i] = ' ';
		else break;
	}

	string[5] = 0x00;

	print_s_sci1(string);

	return;
}
/*********************************************************************/
/*********************************************************************/
/*O`QTT̐^[~iʂɕ\*/
void print_i_sci1(unsigned char	data)
{

unsigned int		org_data;
unsigned char		i, j, string[16];

	org_data = data;

	/*100̈*/
	j = (unsigned char)(data / 100);
	if(j != 0) string[0] = 0x30 + j;
	else	   string[0] = 0x20;
	
	/*10̈*/
	data = data - (int)j * 100;
	j = (unsigned char)(data / 10);
	if(j != 0) string[1] = 0x30 + j;
	if(j == 0 && org_data >= 100)string[1] = 0x30;
	if(j == 0 && org_data < 100) string[1] = 0x20;
	
	/*1̈*/
	data = data - (int)j * 10;
	j = (unsigned char)data;	
	string[2] = 0x30 + j;

	string[3] = 0x0d;
	string[4] = 0x0a;
	string[5] = 0x00;

	for(i = 0; i < 5; i++)
	{
		while(SCI1.SSR.BIT.TDRE == 0);
		SCI1.TDR = string[i];
		SCI1.SSR.BIT.TDRE = 0;
	}

	return;
}
