#include <3048F.H>
#include "w6v5a.h"

unsigned char sio_comm1(struct SIO *sio, struct SWITCHES *switches)
{
unsigned char	i, j, command, command2;
unsigned char	dist_dat[3], buff_GPS[80];

	command = read_c_scib(1);

	if(command == 0) return(0);


	/*ړ֘AR}h*/
	if(command == '0')
	{
		/**/
		print_c_sci1(command);

		/*TuR}hM*/
		command2 = read_c_sci(1);

		/*~*/
		if(command2 == '0')
		{
			P1.DR.BIT.B4 = 0;
			P1.DR.BIT.B5 = 0;

			sio->running = 0;
		}

		/*w肵Ȃړ*/
		if(command2 == '1')
		{
			sio->running = 1;

			/*[^[N*/
			start_motor(sio->run_dirR, sio->run_dirL);
		}

		/*ړp[^Zbg*/
		if(command2 == '2')
		{
			sio->speed_codeR  = read_c_sci(1);/*Ex(0 to 9)*/
			sio->speed_codeL  = read_c_sci(1);/*x(0 to 9)*/
			sio->run_dirR = read_c_sci(1);/*ړiF: OiAB: ij*/
			sio->run_dirL = read_c_sci(1);/*ړiF: OiAB: ij*/

			sio->pwmR = sio->speed_codeR * 3120;
			sio->pwmL = sio->speed_codeL * 3120;
			set_PWM_value(sio->pwmR, sio->pwmL);
		}

		/*苗̈ړ*/
		if(command2 == '3')
		{
			/*ړ^Cv*/
			sio->move_type = read_c_sci(1);

			/*ړ*/
			sio->move_dir = read_c_sci(1);

			/*ړ*/
			sio->move_val = read_ii_sci1b();

			/*ԗւ̃GR[_ړ𐧌䂷ړ[h*/
			if(sio->move_type >= 2)/*PLLx䂠*/
			{
				move1(sio);
			}
			else/*x䖳*/
			{
				move0(sio);
			}
		}

	}

	
	/*ZTǂݎ聕|[g*/
	if(command == '2')
	{
		/**/
		print_c_sci1(command);

		/*TuR}hM*/
		command2 = read_c_sci(1);

		/*ړԃ|[g*/
		if(command2 == '0')
		{
			/*running	OF~iIj	PFsi@j
						QFsi苗j@@RFsi苗^xj*/
			print_c_sci1(sio->running);

			print_cc_sci1(sio->count_R);/*EGR[_JEgl*/
			print_cc_sci1(sio->count_L);/*GR[_JEgl*/
		}

		/*orci`m7j*/
		if(command2 == '1')
		{
			read_PSDs(dist_dat);
			for(i = 0; i < 3; i++)
			{
				print_c_sci1(dist_dat[i]);
				wait(1);
			}
		}

		/*for̃f[^ob֒p*/
		if(command2 == '2')
		{
			for(i = 0; i < 80; i++) buff_GPS[i] = 0;

			/*؂̂Ƃ܂œǂݔ΂*/
			while(SCI0.SSR.BIT.ORER != 0 || SCI0.SSR.BIT.FER != 0 || SCI0.SSR.BIT.PER != 0)
			{
				i = SCI0.SSR.BIT.ORER;
				i = SCI0.SSR.BIT.FER;
				i = SCI0.SSR.BIT.PER;

				SCI0.SSR.BIT.ORER = 0;
				SCI0.SSR.BIT.FER = 0;
				SCI0.SSR.BIT.PER = 0;

				wait(50);
			}
			/*Pǂ*/
			i = read_c_sci(0);

			/*pJn*/
			while(1)
			{
				buff_GPS[0] = read_c_sci(0);
				if(buff_GPS[0] == '@')
				{
					for(j = 1; j < 57; j++) buff_GPS[j] = read_c_sci(0);
					break;
				}
			}
			for(j = 0; j < 57; j++) print_c_sci1(buff_GPS[j]);
		}
	}


	/*PSD@ON/OFF */
	if(command == '4')
	{
		/*M*/
		print_c_sci1(command);

		switches->PSD_switch	= read_c_sci(1) - '0';
		if(switches->PSD_switch == 1)	P5.DR.BIT.B3 = 1;
		else							P5.DR.BIT.B3 = 0;
	}


	/*Testing*/
	if(command == '9')
	{
		print_s_sci1("-----------------------------");
		print_ii_sci1(sio->count_R);
		print_ii_sci1(sio->count_L);
	}

	/*seXg*/
	if(command == 'a')
	{
		/*ړ^Cv*/
		sio->move_type = 2;

		/*ړ*/
		sio->move_dir = 1;

		/*ړ*/
		sio->move_val = 600;/*Cbot*/

		/*ԗւ̃GR[_ړ𐧌䂷ړ[h*/
		move1(sio);

		/*ړxZbgiPXbg̎ԁiPʂ͂jj*/
		sio->int_countR = 18;
		sio->int_countL = 18;
	}
	return(1);
}