#include <3048F.H>
#include "w6v5a.h"

/*******************************************************************/
/**vURpړjbgsQ@vO@@@@@@@***/
/*******************************************************************/

void main(void)
{
unsigned char	i, state_r, state_l, state_count_r, state_count_l;
unsigned int	jj, gain0, interval, pwm_max_delta, pwm_min;

struct SIO		sio;
struct SWITCHES switches;


	init_main();
	init_switch(&sio, &switches);

	gain0 = 15;
	pwm_max_delta = 500;
	pwm_min = 3125 * 4;

	ITU4.TCNT = 0;
	interval = 0;

	/*GR[_̃[Nϐ*/
	state_count_r = 0;
	state_count_l = 0;
	state_r = 0;
	state_l = 0;

	/*C[v*/
	while(1)
	{
		i = sio_comm1(&sio, &switches);

		/*ԗւ̃GR[_ǂݎ*/
		read_encorder(&sio);

		/*̋𑖂`FbN*/
		/*sio.running: 0͒~A1͋K薳Ȃ̂2ȏ̎`FbN{*/
		if(sio.running > 1) dist_check(&sio);

		/*x䂠ňړ̏ꍇ̑x*/
		if(sio.running == 3)
		{
			/*x*/
			speed_adjst(&sio);

			/*x[XJE^@JEgAbv*/
			if((ITU4.TCNT - sio.TCNT1_R) > sio.int_countR)
			{
				sio.base_countR++;
				sio.TCNT1_R = ITU4.TCNT;
			}

			if((ITU4.TCNT - sio.TCNT1_L) > sio.int_countL)
			{
				sio.base_countL++;
				sio.TCNT1_L = ITU4.TCNT;
			}

			/*x̓*/
			if(sio.base_countR > sio.count_R)/*x*/
			{
				jj = gain0 * (sio.base_countR - sio.count_R);
				if (jj > pwm_max_delta) jj = pwm_max_delta;
				if(sio.pwmR < ITU2.GRB - jj) sio.pwmR = sio.pwmR + jj;
			}
			else/**/
			{
				jj = gain0 * (sio.count_R - sio.base_countR);
				if (jj > pwm_max_delta) jj = pwm_max_delta;
				if(sio.pwmR > jj + pwm_min) sio.pwmR = sio.pwmR - jj;
			}

			if(sio.base_countL > sio.count_L)/*x*/
			{
				jj = gain0 * (sio.base_countL - sio.count_L);
				if (jj > pwm_max_delta) jj = pwm_max_delta;
				if(sio.pwmL < ITU2.GRB - jj) sio.pwmL = sio.pwmL + jj;
			}
			else/**/
			{
				jj = gain0 * (sio.count_L - sio.base_countL);
				if (jj > pwm_max_delta) jj = pwm_max_delta;
				if(sio.pwmL > jj + pwm_min) sio.pwmL = sio.pwmL - jj;
			}
			/*ovlpXύX*/
			set_PWM_value(sio.pwmR, sio.pwmL);
		}
		/***********************************************************/

		
		/*4m secŃ[v܂킷*/
		while((ITU4.TCNT - interval) < 3);
		if(ITU4.TCNT > 64000)
		{
			ITU4.TCNT = 0;
			sio.TCNT1_R = 0;
			sio.TCNT1_L = 0;
		}
		interval = ITU4.TCNT;
	}
}
