struct SIO
{
	unsigned char	speed_codeR, speed_codeL;		/*Xs[hݒl*/
	unsigned char	run_dirR, run_dirL;				/*ԗւ̉]*/
	unsigned char	running;						/*sԃtO*/
	unsigned char	move_type;						/*ړ^Cv*/
	unsigned char	move_dir;						/*ړ*/
	unsigned int	move_val;						/*ړ*/
	unsigned int	run_time;
	unsigned int	run_countL, run_countR;			/*s\苗ɑΉXbg̃JEg*/
	unsigned int	count_R, count_L;				/*݂̑sJEg*/
	unsigned int	TCNT1_R, TCNT1_L;				/*PWMpX*/
	unsigned int	base_countR, base_countL;		/*Xs[hݒl(JE^p)*/
	unsigned int	int_countR, int_countL;			/*x̃JEgliokkpj*/
	unsigned int	pwmR, pwmL;						/*ovlpXp̂hstDfq`ւ̐ݒl*/
};

struct SWITCHES
{
	unsigned char	PSD_switch;
	int				adxl_offset[2];
};

/*utils1.c*/
void move1(struct SIO *sio);
void move0(struct SIO *sio);
void set_PWM_value(unsigned int pwm_R, unsigned int pwm_L);
void start_motor(unsigned char move_dir_R, unsigned char move_dir_L);

/*utils2.c*/
void dist_check(struct SIO *sio);
void speed_adjst(struct SIO *sio);
void read_encorder(struct SIO *sio);

/*sio2.c*/
unsigned char sio_comm1(struct SIO *sio, struct SWITCHES *switches);

/*inits.c*/
void init_main(void);
void init_switch(struct SIO *sio, struct SWITCHES *switches);

/*sio1.c*/
unsigned int read_i_sci1(void);
unsigned int read_ii_sci1(void);
unsigned int read_ii_sci1b(void);
unsigned char read_c_scib(unsigned char ch);
unsigned char read_c_sci(unsigned char ch);

void print_cc_sci1(unsigned int data);
void print_c_sci1(unsigned char	data);
void print_s_sci1(char string[80]);
void print_ii_sci1(unsigned int data);
void print_i_sci1(unsigned char	data);

/**/
void wait(unsigned int time);
void read_PSDs(unsigned char dist_dat[3]);
