#include <3048F.H>
#include "w6v5a.h"

/****************************************************************/
/*                                                              */
/****************************************************************/
void init_main(void)
{
unsigned char	i;

	/*|[g1,5o͂ɐݒ*/
	P1.DDR = 0xff;
	P5.DDR = 0xff;

	/***********************************/
	/*vO}uIV[^@TZbg 1kHz*/
	P5.DR.BYTE = 0x01;

	/*ԃJEgpiTCLKA)*/
	ITU4.TCR.BIT.TPSC = 4;
	/*Start*/
	ITU.TSTR.BIT.STR4 = 1;

	/***********************************/
	/*ITU PWM[h̐ݒ*/
	/*NbNWT*/
	ITU2.TCR.BIT.TPSC = 3;
	ITU3.TCR.BIT.TPSC = 3;

	/*GRB}b`ŃJE^NA*/
	ITU2.TCR.BIT.CCLR = 2;
	ITU3.TCR.BIT.CCLR = 2;

	/*}b`NAق̃WX^l傫邱ƁII*/
	ITU2.GRA = 20000;
	ITU2.GRB = 31250;

	ITU3.GRA = 20000;
	ITU3.GRB = 31250;

	ITU.TMDR.BIT.PWM2 = 1;
	ITU.TMDR.BIT.PWM3 = 1;

	ITU.TSTR.BIT.STR2 = 1;
	ITU.TSTR.BIT.STR3 = 1;

	/*VAC^[tFCX*******************/
	SCI1.SCR.BYTE	= 0x00;
	SCI1.SMR.BYTE	= 0x00;
	/*Clock 25MHz / 19200 bps*/
	SCI1.BRR		= 40;

	SCI0.SCR.BYTE	= 0x00;
	SCI0.SMR.BYTE	= 0x00;
	/*Clock 25MHz / 9800 bps*/
	SCI0.BRR		= 80;

	wait(1);

	SCI1.SCR.BYTE	= 0x30;
	SCI0.SCR.BYTE	= 0x30;
	
	i = SCI1.SSR.BYTE;
	i = SCI0.SSR.BYTE;

    /*A/DRo[^@WX^ݒ*/
	/*Pꃂ[h*/
	AD.CSR.BIT.SCAN = 0;
	/*vXe[g134*/
	AD.CSR.BIT.CKS = 1;
}

/**********************************************/
/*   \tgEFAXCb`ޏ             */
/**********************************************/
void init_switch(struct SIO *sio, struct SWITCHES *switches)
{

	/*[^[hCuhb@nm*/
	P1.DR.BIT.B0 = 1;
	P1.DR.BIT.B2 = 1;

	/*sԕϐ@OF~@PFtB[hobNݒ薳ړ@QF@RFxtB[hobNݒLňړ*/
	sio->running = 0;

	/*orcюԗւ̃GR[_nm*/
	switches->PSD_switch = 1;
	P5.DR.BIT.B3 = 1;

	/*pwmݒl*/
	sio->pwmR = ITU2.GRA;
	sio->pwmL = ITU3.GRA;

	/*ŒᑬxɃZbgi傫قǒxȂj*/
	sio->int_countR = 999;
	sio->int_countL = 999;

	sio->speed_codeR = 8;
	sio->speed_codeL = 8;

	sio->run_dirR = 'F';
	sio->run_dirL = 'F';

	sio->pwmR = sio->speed_codeR * 3120;
	sio->pwmL = sio->speed_codeL * 3120;
	set_PWM_value(sio->pwmR, sio->pwmL);

}
