#include <3048F.H>
#include "w6v5a.h"

/**************************************************************/
/*
Eړށ@iAɐAMn(unsigned char)

Eړ(unsigned char)
	i		PFOi				@OFi
	ɐ		PFEivj	@OFivj
	Mn	PFEivj	@OFivj

Eړ(unsigned int)
	i		mmPʁiP`RQVUVj
	ɐ		mmPʁiP`RQVUVj
	Mn	xPʁiP`PWOj

*/
/**************************************************************/
void move1(struct SIO *sio)
{
unsigned char	move_dir_L, move_dir_R;
unsigned int	run_count;

	if(sio->move_type == 0 || sio->move_type == 1)
	{
		return;
	}

	/*OiAi*/
	if(sio->move_type == 2)
	{
		/*ړp[^vZ*/
		if(sio->move_dir == 1)
		{
			move_dir_L = 'F';
			move_dir_R = 'F';
		}
		else
		{
			move_dir_L = 'B';
			move_dir_R = 'B';
		}
	}

	/*Mn*/
	if(sio->move_type == 3)
	{
		/*ړp[^vZ*/
		if(sio->move_dir == 1)
		{
			move_dir_L = 'F';
			move_dir_R = 'B';
		}
		else
		{
			move_dir_L = 'B';
			move_dir_R = 'F';
		}

		/*͒l(pxj^Csɕϊ*/
		sio->move_val = (unsigned int)((float)sio->move_val * (float)1.361357);
	}

	/*Mn*/
	if(sio->move_type == 4)
	{
		/*ړp[^vZ*/
		if(sio->move_dir == 1)
		{
			move_dir_L = 'F';
			move_dir_R = 'S';
		}
		else
		{
			move_dir_L = 'S';
			move_dir_R = 'F';
		}

		/*͒l(pxj^Csɕϊ*/
		sio->move_val = (unsigned int)((float)sio->move_val * (float)2.722714);
	}

	run_count = (unsigned int)((float)sio->move_val / (float)7.5922);
	if(run_count > 1) run_count = run_count - 1;/*ňړ镪}CiX*/


	/*hstփ[^[p̂ovlp[^ݒ*/
	if(sio->move_type == 2)
	{
		sio->run_countR = run_count;
		sio->run_countL = run_count;
	}
	if(sio->move_type == 3)
	{
		sio->run_countR = run_count;
		sio->run_countL = run_count;
	}
	if(sio->move_type == 4)
	{
		if(sio->move_dir == 1)
		{
			sio->run_countL = run_count;
			sio->run_countR = 0;
		}
		else
		{
			sio->run_countL = 0;
			sio->run_countR = run_count;
		}
	}

	/****************************/
	/*sJn*/
	/*[^[N̍Œᑬx*/
	sio->pwmR = 5 * 3120;
	sio->pwmL = 5 * 3120;
	set_PWM_value(sio->pwmR, sio->pwmL);

	/*GR[_@JEglNA*/
	sio->count_R = 0;
	sio->count_L = 0;

	/*GR[_@JEglNA*/
	sio->count_R = 0;
	sio->count_L = 0;

	/*sJE^Zbg*/
	sio->base_countR = 0;
	sio->base_countL = 0;

	ITU4.TCNT = 0;
	sio->TCNT1_R = 0;
	sio->TCNT1_L = 0;

	/*sԃtOZbg*/
	sio->running = 3;

	/*[^[N*/
	start_motor(move_dir_R, move_dir_L);
}

/**************************************************************/
/*
Eړށ@iAMn(unsigned char)

Eړ(unsigned char)
	i		OFOi				@PFi
	Mn	OFEivj	@PFivj

Eړ(unsigned int)
	i		mmPʁiP`RQVUVj
	Mn	xPʁiP`PWOj

*/
/**************************************************************/
void move0(struct SIO *sio)
{
unsigned char	move_dir_L, move_dir_R;
unsigned int	pwm;

	if(sio->move_type != 0 && sio->move_type != 1) return;

	/*OiAi*/
	if(sio->move_type == 0)
	{
		/*ړp[^vZ*/
		if(sio->move_dir == 1)
		{
			move_dir_L = 'F';
			move_dir_R = 'F';
		}
		else
		{
			move_dir_L = 'B';
			move_dir_R = 'B';
		}
	}

	/*Mn*/
	if(sio->move_type == 1)
	{
		/*ړp[^vZ*/
		if(sio->move_dir == 1)
		{
			move_dir_L = 'F';
			move_dir_R = 'B';
		}
		else
		{
			move_dir_L = 'B';
			move_dir_R = 'F';
		}

		/*͒l(pxj^Csɕϊ*/
		sio->move_val = (unsigned int)((float)sio->move_val * (float)1.361357);
	}

	if(sio->move_val > (unsigned int)300)
	{
		pwm = 8 * 3120;
	}
	else if(sio->move_val > (unsigned int)100 && sio->move_val <= (unsigned int)300)
	{
		pwm = 6 * 3120;
	}
	else
	{
		pwm = 4 * 3120;
	}

	/*ړGR[_JEgɊZ*/
	sio->run_countL = (unsigned int)((float)sio->move_val / (float)7.5922);
	sio->run_countR = sio->run_countL;

	/*[^[p̂ovlp[^ݒ*/
	set_PWM_value(pwm, pwm);

	/*GR[_@JEglNA*/
	sio->count_R = 0;
	sio->count_L = 0;

	/*sԃtOZbg*/
	sio->running = 2;
	
	/*[^[N*/
	start_motor(move_dir_R, move_dir_L);

	return;
}

/****************************************************************/
/*sp[^[N*/
/****************************************************************/
void start_motor(unsigned char move_dir_R, unsigned char move_dir_L)
{
	/*sJn*/
	if(move_dir_R == 'F')
	{
		P1.DR.BIT.B1 = 0;
	}
	else
	{
		P1.DR.BIT.B1 = 1;
	}

	if(move_dir_L == 'F')
	{
		P1.DR.BIT.B3 = 0;
	}
	else
	{
		P1.DR.BIT.B3 = 1;
	}

	/*u[L*/
	P1.DR.BIT.B4 = 1;
	P1.DR.BIT.B5 = 1;
}

/****************************************************************/
/*PWMp̐lWX^ɃZbg*/
/****************************************************************/
void set_PWM_value(unsigned int pwm_R, unsigned int pwm_L)
{

	/*ovl~*/
	ITU.TSTR.BIT.STR2 = 0;
	ITU.TSTR.BIT.STR3 = 0;

	ITU2.GRA = pwm_R;
	ITU3.GRA = pwm_L;

	/*ovlJn*/
	ITU.TSTR.BIT.STR2 = 1;
	ITU.TSTR.BIT.STR3 = 1;
}

/*********************************************************************/
/*O㍶E@SPSD̑f[^擾*/
/*********************************************************************/
void read_PSDs(unsigned char dist_dat[3])
{
unsigned char	i;

	for(i = 0; i < 4; i++)
	{
		/*ChI*/
		AD.CSR.BIT.CH = i;
		/*ϊX^[g*/
		AD.CSR.BIT.ADST = 1;

		while(AD.CSR.BIT.ADST == 1);

		if(i == 0) dist_dat[0] = (unsigned char)(AD.DRA / 256);/*Oorc*/
		/*i == 1̌orc͓PB*/
		if(i == 2) dist_dat[1] = (unsigned char)(AD.DRC / 256);/*EHorc*/
		if(i == 3) dist_dat[2] = (unsigned char)(AD.DRD / 256);/*Horc*/
	}
}

/*********************************************************************/
/*********************************************************************/
void wait(unsigned int time)
{
	/*PJEgłP*/
	ITU4.TCNT = 0;
	while(ITU4.TCNT < time);
}
