#include <3048F.H>
#include "w6v5a.h"

/***********************************************************/
/*ԗւ̃GR[_gđĂ鎞̑sI*/
/***********************************************************/
void dist_check(struct SIO *sio)
{
	/***********************************/
	/*Eԗւ̑s`FbN*/
	if(sio->run_countR < sio->count_R)
	{
		/*~*/
		P1.DR.BIT.B4 = 0;
		sio->run_countR = 0;
	}
	/***********************************/
	/*ԗւ̑s`FbN*/
	if(sio->run_countL < sio->count_L)
	{
		/*~*/
		P1.DR.BIT.B5 = 0;
		sio->run_countL = 0;
	}
	/***********************************/
	/*i̎́A~ɐiĤhߍEɃ[^[~*/
	if((sio->move_type == 0 || sio->move_type == 2) && (P1.DR.BIT.B0 == 0 || P1.DR.BIT.B2 == 0))
	{
		/*~*/
		P1.DR.BIT.B4 = 0;
		P1.DR.BIT.B5 = 0;
		sio->run_countR = 0;
		sio->run_countL = 0;
	}
	/***********************************/
	/*̃[^[~܂瑖stOZbg*/
	if(P1.DR.BIT.B4 == 0 && P1.DR.BIT.B5 == 0) sio->running = 0;
}

/***********************************************************/
/*c̑sɉXs[h*/
/***********************************************************/
void speed_adjst(struct SIO *sio)
{
unsigned int	ii, step, acc_limit;
unsigned int	pwm_max, pwm_min;

	step = 1;
	acc_limit = 24 * 2; /*cԗւQ]ɂȂ猸i܂ł͉j*/

	/*Œᑬx@gႢiGR[_Pς鎞ԁj*/
	pwm_max = 120;

	/*ōx@giGR[_Pς鎞ԁj*/
	pwm_min = 18;

	/***********************************/
	/*Eԗւ̑xύX*/
	/*ڕWOŌBƂ͉B*/
	ii = sio->run_countR - sio->count_R;
	if(ii > acc_limit && sio->int_countR > pwm_min)
		sio->int_countR = sio->int_countR - step;			/**/
		
	if(ii < acc_limit && sio->int_countR < pwm_max)
		sio->int_countR = sio->int_countR + step;			/**/

	if (sio->int_countR < pwm_min) sio->int_countR = pwm_min;
	if (sio->int_countR > pwm_max) sio->int_countR = pwm_max;
	/***********************************/
	/*ԗւ̑xύX*/
	/*ڕWOŌBƂ͉B*/
	ii = sio->run_countL - sio->count_L;
	if(ii > acc_limit && sio->int_countL > pwm_min)
		sio->int_countL = sio->int_countL - step;			/**/
		
	if(ii < acc_limit && sio->int_countL < pwm_max)
		sio->int_countL = sio->int_countL + step;			/**/

	if (sio->int_countL < pwm_min) sio->int_countL = pwm_min;
	if (sio->int_countL > pwm_max) sio->int_countL = pwm_max;
}

/***********************************************************/
/*ԗւ̃GR[_ǂ*/
/***********************************************************/
void read_encorder(struct SIO *sio)
{
static unsigned char state_r = 0, state_l = 0, state_count_r = 0, state_count_l = 0;

	if(PA.DR.BIT.B1 != state_r)
	{
		state_count_r++;
		if(state_count_r > 2)
		{
			state_r = PA.DR.BIT.B1;
			state_count_r = 0;
			sio->count_R++;
		}
	}
	/*GR[_*/
	if(PA.DR.BIT.B2 != state_l)
	{
		state_count_l++;
		if(state_count_l > 2)
		{
			state_l = PA.DR.BIT.B2;
			state_count_l = 0;
			sio->count_L++;
		}
	}
}